#include "stdafx.h"
#include "ListaAlunos.h"

ListaAlunos::ListaAlunos(int na, char* n)
{
	numero_alunos = na;
	cont_alunos	  = 0;           

	pElAlunoPrim  = NULL;
	pElAlunoAtual = NULL;

	strcpy (nome, n ); 
}

ListaAlunos::~ListaAlunos()
{
   limpaLista();
}

void ListaAlunos::limpaLista()
{
   Elemento<Aluno> *paux1;
   Elemento<Aluno> *paux2;

   paux1 = pElAlunoPrim;
   paux2 = paux1;

   while (paux1 != NULL)
   {
		paux2 = paux1->getProximo();
	    delete (paux1);
        paux1 = paux2;		 
   }

   pElAlunoPrim  = NULL;
   pElAlunoAtual = NULL;
}

void ListaAlunos::incluaAluno ( Aluno* pa )
{
    // Aqui  criado um ponteiro para LAluno
    Elemento<Aluno>* paux;
    // Aqui  criado um objeto LAluno, sendo seu endereo armazenado em aux
    paux = new Elemento<Aluno>( );

	paux->setNome(pa->getNome());
	
    // Aqui recebe uma cpia do objeto interm.
    paux->setInfo ( pa );

    if (
		  ( ( cont_alunos < numero_alunos ) && ( pa != NULL) ) ||
	  	  ( ( -1 == numero_alunos)			&& ( pa != NULL) )
	   )
    {   
       if ( pElAlunoPrim == NULL )
       {
          pElAlunoPrim   = paux;
          pElAlunoAtual  = paux;
       }
       else
       {
          pElAlunoAtual->setProximo(paux);
          paux->setAnterior(pElAlunoAtual);
          pElAlunoAtual = paux;
       }
       cont_alunos++;
    }
    else
    {
       //printf ("Aluno no includo. Turma j lotada em %i alunos \n", numero_alunos );
	   cout << "Aluno no includo. Turma j lotada em " << numero_alunos << " alunos." << endl;
    }

}

void ListaAlunos::listeAlunos()
{
    Elemento<Aluno>* paux;
    paux = pElAlunoPrim;

    while (paux != NULL)
    {
         //printf(" Aluno %s matriculado na Disciplina %s. \n", aux->getNome(), nome);
		 cout << " Aluno " << paux->getNome() << " matriculado na Disciplina " << nome << "." << endl;
         paux = paux->getProximo();
    }
}

void ListaAlunos::listeAlunos2()
{
    Elemento<Aluno>* paux;
    paux = pElAlunoAtual;

    while (paux != NULL)
    {
       //printf(" Aluno %s matriculado na Disciplina %s \n", aux->getNome(), nome);
	   cout << " Aluno " << paux->getNome() << " matriculado na Disciplina " << nome << "." << endl;
       paux = paux->getAnterior();
    }
}


void ListaAlunos::graveAlunos()
{
	ofstream GravacaoAlunos ("alunos.dat", ios::out);

	if (!GravacaoAlunos)
	{
		cerr << "Arquivo no pode ser aberto" << endl;
		fflush(stdin);
		getchar();
	}

    Elemento<Aluno>* pauxElAluno;
	pauxElAluno = pElAlunoPrim;

    while (pauxElAluno != NULL)
    {
		 Aluno* pauxAluno;
         
		 pauxAluno = pauxElAluno->getInfo();

		 GravacaoAlunos << pauxAluno->getId() << ' ' 
						<< pauxAluno->getRA() << ' ' 
						<< pauxAluno->getNome() 
						<< endl;
         pauxElAluno = pauxElAluno->getProximo();
    } 

	GravacaoAlunos.close();
}

void ListaAlunos::recupereAlunos()
{
	ifstream RecuperacaoAlunos ("alunos.dat", ios::in);

	if (!RecuperacaoAlunos)
	{
		cerr << "Arquivo no pode ser aberto" << endl;
		fflush(stdin);
		getchar();
	}

	limpaLista();

	while (!RecuperacaoAlunos.eof())
    {
		Aluno* pauxAluno;
         
		pauxAluno = new Aluno(-1);

		int				id;
	   	int				RA;
        char			nome[150] ;

		RecuperacaoAlunos	>> id >> RA >> nome;

		if (0 != strcmp(nome, ""))
		{
			pauxAluno->setId(id);
			pauxAluno->setRA(RA);
			pauxAluno->setNome(nome);
		
			incluaAluno (pauxAluno);  
		}
    } 

	RecuperacaoAlunos.close();
}